/*
 * rf01.h
 *
 *  Created on: 23.11.2009
 *      Author: user
 */

#ifndef RF01_H_
#define RF01_H_

#define MHZ315 (0<<11)
#define MHZ433 (1<<11)
#define MHZ868 (2<<11)
#define MHZ915 (3<<11)

#define PF85 	(0<<4)
#define PF9 	(1<<4)
#define PF95 	(2<<4)
#define PF10 	(3<<4)
#define PF105 	(4<<4)
#define PF11 	(5<<4)
#define PF115 	(6<<4)
#define PF12 	(7<<4)
#define PF125 	(8<<4)
#define PF13 	(9<<4)
#define PF135 	(A<<4)
#define PF14 	(B<<4)
#define PF145 	(C<<4)
#define PF15 	(D<<4)
#define PF155 	(E<<4)
#define PF16 	(F<<4)

#define KHZ400 (1<<1)
#define KHZ340 (2<<1)
#define KHZ270 (3<<1)
#define KHZ200 (4<<1)
#define KHZ134 (5<<1)
#define KHZ67  (6<<1)

#define LOWBAT (1<<10)
#define WAKEUP (1<<9)
#define CRYSTAL (1<<8)
#define CLOCKOUT (0<<0)


#define FREQ315(x) (10*1*(31+x/4000))
#define FREQ433(x) (10*1*(43+x/4000))
#define FREQ868(x) (10*2*(43+x/4000))
#define FREQ915(x) (10*3*(30+x/4000))

#define VDI_RSSI (0<<6)
#define VDI_DQD (1<<6)
#define VDI_CLOCK (2<<6)
#define VDI_ALWAYS (3<<6)

#define LNA0 (0<<4)
#define LNA14 (1<<4)
#define LNA6  (2<<4)
#define LNA20 (3<<4)

#define RSSI103 (0<<1)
#define RSSI97 (1<<1)
#define RSSI91 (2<<1)
#define RSSI85 (3<<1)
#define RSSI79 (4<<1)
#define RSSI73 (5<<1)
#define RSSI67 (6<<1)
#define RSSI61 (7<<1)

#define ENABLE_RECEIVER (1<<0)

#define CLK1 (0<<5)
#define CLK125 (1<<5)
#define CLK166 (2<<5)
#define CLK2 (3<<5)
#define CLK25 (4<<5)
#define CLK333 (5<<5)
#define CLK5 (6<<5)
#define CLK10 (7<<5)

#define AFC (1<<0)
#define FRQ_REG (1<<1)
#define FINE_MODE (1<<2)
#define STORE_FRQ (1<<3)

#define DEVOFF (0<<4)
#define DEV31 (1<<4)
#define DEV15 (2<<4)
#define DEV7  (3<<4)

#define OFFS_REG (1<<1)

#define OFFS_CALC (1<<0)

#define AUTO_OFF (0<<6)
#define AUTO_ONCE (1<<6)
#define AUTO_ONLY (2<<6)
#define AUTO_INDEPENDENT (3<<6)

#define AUTO_CLOCK_RECOVERY (1<<7)
#define FAST_CLOCK_RECOVERY (1<<6)
#define DIGITAL_FILTER (1<<3)

#define FIFO_VDI (0<<2)
#define FIFO_SYNC (1<<2)
#define FIFO_ALWAYS (3<<2)
#define FIFO_RESERVED (2<<2)

#define FIFOLEVEL(x) (x<<4)

#define FIFO_FILL (1<<1)
#define FIFO_ENABLE (1<<0)

#define DISABLE_RESET (1<<0)

#define RF_STATUS_FFIT (1<<15)
#define RF_STATUS_FFOV (1<<14)
#define RF_STATUS_WKUP (1<<13)
#define RF_STATUS_LBD (1<<12)
#define RF_STATUS_FFEM (1<<11)
#define RF_STATUS_RSSI (1<<10)




// _I = INPUT PORT
// _O = OUTPUT PORT
// _P = PORT INDEX
// _D = DATA DIRECTION REGISTER

// SPI SCK (clock, output)
#define RFM12B_SCK_I PINC
#define RFM12B_SCK_O PORTC
#define RFM12B_SCK_P PC1
#define RFM12B_SCK_D DDRC

#define RFM12B_SCK_INIT() RFM12B_SCK_D |= (1<<(RFM12B_SCK_P))
#define RFM12B_SCK_LOW() RFM12B_SCK_O &= ~(1<<(RFM12B_SCK_P))
#define RFM12B_SCK_HIGH() RFM12B_SCK_O |= (1<<(RFM12B_SCK_P))

// SPI MISO / SDO (master in slave out, input)
#define RFM12B_MISO_I PINC
#define RFM12B_MISO_O PORTC
#define RFM12B_MISO_P PC0
#define RFM12B_MISO_D DDRC

#define RFM12B_MISO_INIT() RFM12B_MISO_D &= ~(1<<(RFM12B_MISO_P))
#define RFM12B_MISO_LOW() ~(RFM12B_MISO_HIGH())
#define RFM12B_MISO_HIGH() RFM12B_MISO_I & (1<<(RFM12B_MISO_P))

// SPI MOSI / SDI (master out slave in, output)
#define RFM12B_MOSI_I PINC
#define RFM12B_MOSI_O PORTC
#define RFM12B_MOSI_P PC3
#define RFM12B_MOSI_D DDRC

#define RFM12B_MOSI_INIT() RFM12B_MOSI_D |= (1<<(RFM12B_MOSI_P))
#define RFM12B_MOSI_LOW() RFM12B_MOSI_O &= ~(1<<(RFM12B_MOSI_P))
#define RFM12B_MOSI_HIGH() RFM12B_MOSI_O |= (1<<(RFM12B_MOSI_P))

// SPI SS / CS (slave select, output)
#define RFM12B_SS_I PINC
#define RFM12B_SS_O PORTC
#define RFM12B_SS_P PC2
#define RFM12B_SS_D DDRC

#define RFM12B_SS_INIT() RFM12B_SS_D |= (1<<(RFM12B_SS_P))
#define RFM12B_SS_LOW() RFM12B_SS_O &= ~(1<<(RFM12B_SS_P))
#define RFM12B_SS_HIGH() RFM12B_SS_O |= (1<<(RFM12B_SS_P))





#define RF_CHANNEL_0 1670 // 868,35Mhz
#define RF_CHANNEL_1 1870 // 869,35Mhz


#define RF_BAUD_38K4 8	// 38,31kBps
#define RF_BAUD_19K2 17	// 19,19kBps
#define RF_BAUD_4K8 71	// 4,8kBps

void rfphyInit(void);
void rfphySetRxMode();

#endif /* RF01_H_ */
