/*
 * rfm01.c
 *
 *  Created on: 23.11.2009
 *      Author: user
 */

#include <avr/io.h>
#include <stdio.h>
#include <stdlib.h>
#include <util/delay.h>
#include "rf01.h"

uint8_t g_buffer[50];

void initUART() {
	UBRR0L = 0xc; // 38,4kBaud @ 8 Mhz
	UCSR0B = (1<<RXEN0) | (1<<TXEN0); // Rx enable, Tx enable, Receive-interrupt enable
}

void uartByte(const char c) {
	while(!(UCSR0A&(1<<UDRE0)));
	UDR0 = c;
}
void uartString(const char *s) {
	while(*s !=0 ) {
		uartByte(*s);
		s++;
	}
}

void uartByteLn(const char c) {
	uartByte(c);
	uartByte('\r');
}

void uartWordLn(const uint16_t w) {
	uartByte(w>>8);
	uartByte(w);
	uartByte('\r');
}

inline void delay100(void) {
	_delay_ms(25); _delay_ms(25); 
	_delay_ms(25); _delay_ms(25);
}

int main(void) {
	uint8_t i=0,j=0;
	delay100();
	rfphyInitHard();
	delay100();

	initUART();	
	rfphyInit();
	uartString("Init\r");


	while(1) {
		if((PIND&(1<<PD3)) == 0) { 		//nIRQ low?
			g_buffer[i] = rfphyReceive();
			uartByte(g_buffer[i]);
			if(g_buffer[i]==0x55) {	// Packet ended?
				for(j=0;j<i;j++) {
					uartByte(g_buffer[j]);
				}
				i=0;
			}
			else
				i++;
		}
	}

	return 0;
}
